/*
Un livello L2 Datalink trasporta numeri senza segno su 16 bit. Applicare il byte stuffing con il valore AAh a un
pacchetto dati che contiene i numeri 9157, 4778, 43523, 21771.
*/
#include <stdio.h>

int main(void)
{
    unsigned char byte[16];
    unsigned int n0,n1,n2,n3;
    int c,i,j,l;

    n0 = 0x23C5;
    n1 = 0x12AA;
    n2 = 0xAA03;
    n3 = 0x550B;

    byte[0]= n0 >> 8; byte[1]= (unsigned char) n0;
    byte[2]= n1 >> 8; byte[3]= (unsigned char) n1;
    byte[4]= n2 >> 8; byte[5]= (unsigned char) n2;
    byte[6]= n3 >> 8; byte[7]= (unsigned char) n3;

    l = 4 * sizeof(short);  // 4*2
    printf("La sequenza originale: ");
    for (i=0; i<l; i++) printf("%02x ",byte[i]);

    c = 0;
    for(i=0; i<l; i++)
    {
      if(byte[i]==0xAA)
      {
        for(j=l+1; j>i; j--)
        {
          byte[j]=byte[j-1];
        }
        byte[i]=0xAA;
        i++;
        c++;
      }
    }

    printf("\nLa sequenza 'riempita': ");
    for (i=0; i<l+c; i++) printf("%02x ",byte[i]);

    return 0;
}
